{    var   : }
{ N, ITMAX }
Unit MNA6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNA6R1_p, FMNA6R_p;

procedure MNA6R(var N :Integer; var X :Array of Real; var Y :Real;
                var P :Array of Real; EPS :Real; var IFLAG :Integer;
                var ITMAX :Integer);

implementation

procedure MNA6R(var N :Integer; var X :Array of Real; var Y :Real;
                var P :Array of Real; EPS :Real; var IFLAG :Integer;
                var ITMAX :Integer);
var
I,J,IBIG :Integer;
FP,DEL,PCOM,XICOM,FPTT,T :Real;
PT :Array [0..49] of Real;
PTT :Array [0..49] of Real;
XIT :Array [0..49] of Real;
const
ONE :Real = 1.0;
TWO :Real = 2.0;
ZERO :Real = 0.0;
label
_5,_10,_20,_30,_40,_50,_60,_70,_80,_90;
begin
IFLAG := 0;
_MNA6RR.elm1 := 0;
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    P[(I-1)+(J-1)*N] := ZERO;
_5:
   end;
 end;
for I:=1 to N do
 begin
  P[(I-1)+(I-1)*N] := ONE;
_10:
 end;
Y := FMNA6R(X,N);
for J:=1 to N do
 begin
  PT[J-1] := X[J-1];
_20:
 end;
_30:
_MNA6RR.elm1 := _MNA6RR.elm1+1;
FP := Y;
IBIG := 0;
DEL := ZERO;
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    XIT[J-1] := P[(J-1)+(I-1)*N];
_40:
   end;
  MNA6R1(X,XIT,N,Y,ITMAX);
  if ( Abs(FP-Y) <= DEL ) 
   then goto _50;
  DEL := Abs(FP-Y);
  IBIG := I;
_50:
 end;
if ( TWO*Abs(FP-Y) <= Abs(EPS)*(Abs(FP)+Abs(Y)) ) 
 then goto _80;
if ( _MNA6RR.elm1 = ITMAX ) 
 then goto _90;
for J:=1 to N do
 begin
  PTT[J-1] := TWO*X[J-1]-PT[J-1];
  XIT[J-1] := X[J-1]-PT[J-1];
  PT[J-1] := X[J-1];
_60:
 end;
FPTT := FMNA6R(PTT,N);
if ( FPTT >= FP ) 
 then goto _30;
T := TWO*(FP-TWO*Y+FPTT)*IntPower(FP-Y-DEL,2)-DEL*IntPower(FP-FPTT,2);
if ( T >= ZERO ) 
 then goto _30;
MNA6R1(X,XIT,N,Y,ITMAX);
for J:=1 to N do
 begin
  P[(J-1)+(IBIG-1)*N] := XIT[J-1];
_70:
 end;
goto _30;
_80:
IFLAG := 1;
_90:
end;

end.
