{    var   : }
{ ITMAX, Y }
Unit MNA6R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNA6R2_p, MNA1R_p, MNA3R_p;

procedure MNA6R1(var X :Array of Real; var XIT :Array of Real;
                N :Integer; var Y :Real; var ITMAX :Integer);

implementation

procedure MNA6R1(var X :Array of Real; var XIT :Array of Real;
                N :Integer; var Y :Real; var ITMAX :Integer);
var
J,IFLAG :Integer;
AX,XX,BX,FA,FX,FB,XMIN :Real;
const
TOL :Real = 1.0E-4;
ZERO :Real = 0.0;
ONE :Real = 1.0;
TWO :Real = 2.0;
label
_10,_20;
begin
_MNA6RC.elm1 := N;
for J:=1 to N do
 begin
  _MNA6RC.elm2[J-1] := X[J-1];
  _MNA6RC.elm3[J-1] := XIT[J-1];
_10:
 end;
AX := ZERO;
XX := ONE;
BX := TWO;
MNA1R(MNA6R2,AX,XX,BX,FA,FX,FB,IFLAG,ITMAX);
MNA3R(MNA6R2,AX,XX,BX,TOL,XMIN,Y,IFLAG,ITMAX);
for J:=1 to N do
 begin
  XIT[J-1] := XMIN*XIT[J-1];
  X[J-1] := X[J-1]+XIT[J-1];
_20:
 end;
end;

end.
